import torch
import numpy as np
import sys
import matplotlib

if sys.platform == 'darwin':
    matplotlib.use("MacOSX") # for mac
else:
    matplotlib.use("TkAgg") # for unix/windows

import matplotlib.pyplot as plt
plt.rcParams["figure.figsize"] = (7, 7) # size of window
plt.ion()
plt.style.use('dark_background')

y = np.array([-3.0, 0])
x = np.array([0, 0])

is_running = True
def button_press_event(event):
    global y
    y = np.array([event.xdata, event.ydata])

def press(event):
    global is_running
    print('press', event.key)
    if event.key == 'escape':
        is_running = False # quits app

def on_close(event):
    global is_running
    is_running = False

fig, _ = plt.subplots()
fig.canvas.mpl_connect('close_event', on_close)
fig.canvas.mpl_connect('button_press_event', button_press_event)
fig.canvas.mpl_connect('key_press_event', press)

length = 2.0
theta_1 = np.deg2rad(-10)
theta_2 = np.deg2rad(-10)

def rotation(theta):
    #TODO
    return theta

while is_running:
    plt.clf()
    plt.title(f'theta_1: {round(np.rad2deg(theta_1))} theta_2: {round(np.rad2deg(theta_2))}')

    t = np.array([0.0, 1.0]) * length
    points = []

    points.append(x)
    points.append(np.array(x) + t)
    #TODO add points

    np_points = np.array(points)

    if len(np_points):
        plt.plot(np_points[:, 0], np_points[:, 1])
    plt.scatter(y[0], y[1], s=50, c='r')

    plt.xlim(-5, 5)
    plt.ylim(0, 10)
    plt.draw()
    plt.pause(1e-3)


